/*******************************************************************************
 * FoxSettingsUIAudio generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSettingsUIAudio extends FoxSettingsUIBase within FoxMenuUI
    config(UI);

enum EAudioSettings
{
    EAS_GameVolume,
    EAS_MusicVolume,
    EAS_FXVolume,
    EAS_DamageCauseAudio,
    EAS_DamageTakenAudio,
    EAS_StaminaAudio,
    EAS_TauntAudio,
    EAS_VOIP,
    EAS_OthersVOIPVolume,
    EAS_Max
};

function Initialize()
{
    ProfileSettings = Outer.Outer.PCOwner.ProfileSettings;
    SetupStrings();
    SetupSettingsScene();
    NumSettings = 9;
    OriginalVals.Length = NumSettings;
    CurrentVals.Length = NumSettings;
    DefaultVals.Length = NumSettings;
    GetOriginalVals();
    GetDefaultVals();
    Outer.Outer.Advance(0.0);
    ei_RevertChanges();
    SetupButtonContainer();
    ConfirmSettingsValidity();
    //return;    
}

function SetupSettingsScene()
{
    Outer.as_addAdditionalButtonContainer("container", int(SettingsContainerProperties.X), int(SettingsContainerProperties.Y), 0, 0, 0, 100, "", "", SettingsContainerProperties.WidgetSpacing, SettingsContainerProperties.MaxListWidth, SettingsContainerProperties.MaxListHeight, false);
    as_addSettingsBG(0, 0);
    Outer.as_addAdditionalButtonContainer("Audio", int(SettingsDividerContainerProperties.X), int(SettingsDividerContainerProperties.Y), 0, 0, 0, 100, "", "", SettingsDividerContainerProperties.WidgetSpacing, SettingsDividerContainerProperties.MaxListWidth, SettingsDividerContainerProperties.MaxListHeight, false);
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("GameVolume"), Outer.LocalizeMenuString("GameVolumeToolTip"), NumberStepperOfThroughMax, 0, "ei_SettingChanged", string(0), false), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("MusicVolume"), Outer.LocalizeMenuString("MusicVolumeToolTip"), NumberStepperOfThroughMax, 0, "ei_SettingChanged", string(1), false), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("EffectsVolume"), Outer.LocalizeMenuString("EffectsVolumeToolTip"), NumberStepperOfThroughMax, 0, "ei_SettingChanged", string(2), false), class'FoxSettingsWidget')));
    as_addSettingsSpacer();
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("DamageCauseVolume"), Outer.LocalizeMenuString("DamageCauseVolumeToolTip"), NumberStepperOfThroughMax, 0, "ei_SettingChanged", string(3), false), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("DamageTakenVolume"), Outer.LocalizeMenuString("DamageTakenVolumeToolTip"), NumberStepperOfThroughMax, 0, "ei_SettingChanged", string(4), false), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("StaminaAudioVolume"), Outer.LocalizeMenuString("StaminaAudioVolumeToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(5)), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("TauntAudio"), Outer.LocalizeMenuString("TauntAudioToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(6)), class'FoxSettingsWidget')));
    // End:0xA84
    if(class'WorldInfo'.static.IsConsoleBuild())
    {
        as_addSettingsSpacer();
        SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("Voice"), Outer.LocalizeMenuString("VoiceToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(7)), class'FoxSettingsWidget')));
        SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("OthersVoice"), Outer.LocalizeMenuString("OthersVoiceToolTip"), NumberStepperOfThroughMax, 0, "ei_SettingChanged", string(8), true), class'FoxSettingsWidget')));
    }
    //return;    
}

function ei_SettingChanged(string WidgetIndexString, string NewSelectedIndexString)
{
    local int WidgetIndex, NewSelectedIndex;

    WidgetIndex = int(WidgetIndexString);
    NewSelectedIndex = int(NewSelectedIndexString);
    super.ei_SettingChanged(WidgetIndexString, NewSelectedIndexString);
    // End:0xBB
    if(WidgetIndex == 1)
    {
        Outer.Outer.PCOwner.SetRTPCValue('Music_Slider', float(NewSelectedIndex), 0, true);
    }
    // End:0x215
    else
    {
        // End:0x1B1
        if(WidgetIndex == 7)
        {
            // End:0x13E
            if(NewSelectedIndex == 0)
            {
                Outer.Outer.PCOwner.VoiceInterface.MuteAll(0, false);
            }
            // End:0x1AE
            if(NewSelectedIndex == 1)
            {
                Outer.Outer.PCOwner.VoiceInterface.UnmuteAll(0);
            }
        }
        // End:0x215
        else
        {
            // End:0x215
            if(WidgetIndex == 8)
            {
                Outer.Outer.PCOwner.SetVoipPlaybackVolume(NewSelectedIndex);
            }
        }
    }
    //return;    
}

function GetOriginalVals()
{
    OriginalVals[0] = float(ProfileSettings.GetDialogVolume() / 10);
    OriginalVals[1] = float(ProfileSettings.GetMusicVolume() / 10);
    OriginalVals[2] = float(ProfileSettings.GetSFXVolume() / 10);
    OriginalVals[3] = float(ProfileSettings.GetSettingInt(129) / 10);
    OriginalVals[4] = float(ProfileSettings.GetSettingInt(130) / 10);
    OriginalVals[5] = float(((ProfileSettings.IsSettingEnabled(131)) ? 1 : 0));
    OriginalVals[6] = float(((ProfileSettings.IsSettingEnabled(133)) ? 1 : 0));
    OriginalVals[7] = float(((ProfileSettings.IsSettingEnabled(124)) ? 1 : 0));
    OriginalVals[8] = float(ProfileSettings.GetSettingInt(125));
    //return;    
}

function GetDefaultVals()
{
    DefaultVals[0] = float(ProfileSettings.GetDefaultInt(123) / 10);
    DefaultVals[1] = float(ProfileSettings.GetDefaultInt(121) / 10);
    DefaultVals[2] = float(ProfileSettings.GetDefaultInt(122) / 10);
    DefaultVals[3] = float(ProfileSettings.GetDefaultInt(129) / 10);
    DefaultVals[4] = float(ProfileSettings.GetDefaultInt(130) / 10);
    DefaultVals[5] = float(((ProfileSettings.IsDefaultSettingEnabled(131)) ? 1 : 0));
    DefaultVals[6] = float(((ProfileSettings.IsDefaultSettingEnabled(133)) ? 1 : 0));
    DefaultVals[7] = float(((ProfileSettings.IsSettingEnabled(124)) ? 1 : 0));
    DefaultVals[8] = float(ProfileSettings.GetDefaultInt(125));
    //return;    
}

function ApplyChanges()
{
    ProfileSettings.SetDialogVolume(int(CurrentVals[0] * float(10)));
    ProfileSettings.SetMusicVolume(int(CurrentVals[1] * float(10)));
    ProfileSettings.SetSFXVolume(int(CurrentVals[2] * float(10)));
    ProfileSettings.SetSettingValueInt(129, int(CurrentVals[3] * float(10)));
    ProfileSettings.SetSettingValueInt(130, int(CurrentVals[4] * float(10)));
    ProfileSettings.SetSettingEnabled(131, ((CurrentVals[5] == float(1)) ? true : false));
    ProfileSettings.SetSettingEnabled(133, ((CurrentVals[6] == float(1)) ? true : false));
    ProfileSettings.SetSettingEnabled(124, ((CurrentVals[7] == float(1)) ? true : false));
    ProfileSettings.SetSettingValueInt(125, int(CurrentVals[8]));
    Outer.Outer.PCOwner.ApplyAudioSettings();
    //return;    
}
